Summary: A fast webserver with minimal memory-footprint (lighttpd)
Summary(ko): 빠른 메모리 기반 웹 서버 (lighttpd)
Name: lighttpd
Version: 1.4.32
Release: 1%{?dist}
Epoch: 1
Source0: http://lighttpd.net/download/%{name}-%{version}.tar.bz2
Source1: %{name}.rotate
Source2: index.html
Source3: flags.tar.gz
Source4: %{name}-monitor
Source5: %{name}-monitor.sysconfig
Source6: %{name}.conf
Source7: mime.conf
Source8: Default.conf
Source9: vhost.conf
Source10: README.config
Source11: lightdigest
Source12: annyung-favicon.ico
Source13: lighttpd.vim-ftdetect
Source14: lighttpd.vim

# thrid party module
Source50: mod_throttlestatus-r1.4.c.authpath
Source51: mod_url-r1.5.c
Source52: mod_auth_nis-r1.6.c
Source53: mod_net_access-r1.2.c
Source54: mod_krisp-r1.5.c
# overwrite mod_status.c for krisp
Source55: mod_status-krisp.c
# overwrite mod_dirlisting.c
Source56: mod_dirlisting-gallery.c

# Core patch
Patch1: %{name}-fileopen.patch
Patch2: %{name}-keepalive.patch
Patch3: %{name}-init.patch
Patch5: %{name}-include-glob.patch
Patch6: %{name}-user-404-page.patch
Patch7: %{name}-tcp-backlog.patch

# Module patch
Patch21: %{name}-mod-indexfile-forbid.patch

# Additional Module patch
Patch50: %{name}-3party-mod-buildenv.patch
Patch51: %{name}-mod-throttlestatus.patch

# lighttpd bug patch per version (from 1.4.15)
Patch500: %{name}-config-zombies.patch

# lighttpd official bug fix
Patch1000: %{name}-%{version}-official-b2465.patch

License: BSD
Group: Networking/Daemons
URL: http://jan.kneschke.de/projects/lighttpd/
Requires: pcre >= 3.1 zlib libkrisp >= 3.1 openssl libimginfo check-utils
Requires: vim-common
BuildRequires: libtool zlib-devel pcre-devel libkrisp-devel >= 3.1
BuildRequires: openssl-devel bzip2-devel libimginfo-devel
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Provides: webserver

#define _debug 1
%define _with_memcache 1
%define _with_ssl 1
%define _unpackaged_files_terminate_build 0

%description
lighttpd is intented to be a frontend for ad-servers which have to deliver
small files concurrently to many connections.

%prep
%setup -q -a 3 -n lighttpd-%{version}

# official pach
%patch1000 -p1

# per version
%patch500 -p1

# Core patch
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

# Module patch
%patch21 -p1

# Additional Module patch
%patch50 -p1
%patch51 -p1

install -m 644 %{SOURCE50} src/mod_throttlestatus.c
install -m 644 %{SOURCE51} src/mod_url.c
install -m 644 %{SOURCE52} src/mod_auth_nis.c
install -m 644 %{SOURCE53} src/mod_net_access.c
install -m 644 %{SOURCE54} src/mod_krisp.c
install -m 644 %{SOURCE55} src/mod_status.c
install -m 644 %{SOURCE56} src/mod_dirlisting.c

%build
rm -rf %{buildroot}

%{?_debug:export CFLAGS="-g3 -O0"}
%{?_debug:export FFLAGS="-g3 -O0"}
%{?_debug:export CXXFLAGS="-g3 -O0"}

autoreconf -fi

export CPPFLAGS="${CPPFLAGS} -I/usr/include/krisp"
%configure \
	--sysconfdir=/etc/lighttpd \
	--libdir=%{_libdir}/lighttpd \
	%{?_with_mysql:       --with-mysql} \
	%{?_with_lua:         --with-lua} \
	%{?_with_memcache:    --with-memcache} \
	%{?_with_ssl:         --with-openssl}

%{__make} %{?_smp_mflags}

%{?_debug: exit 1}

%install

#makeinstall
%{__make} DESTDIR=%{buildroot} install

%{__mkdir} -p %{buildroot}%{_sysconfdir}/{init.d,sysconfig}
%{__install} -m 755 doc/initscripts/rc.lighttpd.redhat %{buildroot}%{_sysconfdir}/init.d/lighttpd
%{__install} -m 644 doc/initscripts/sysconfig.lighttpd %{buildroot}%{_sysconfdir}/sysconfig/lighttpd

%{__mkdir} -p %{buildroot}/home/httpd
%{__mkdir} -p %{buildroot}/var/log/lighttpd
%{__mkdir} -p %{buildroot}%{_sysconfdir}/{logrotate.d,lighttpd/conf.d}
%{__mkdir} -p %{buildroot}%{_bindir}

%{__mkdir} -p %{buildroot}%{_datadir}/lighttpd/flags
cp -af flags/* %{buildroot}%{_datadir}/lighttpd/flags/
%{__install} -m 644 %{SOURCE12} %{buildroot}%{_datadir}/lighttpd/favicon.ico
%{__install} -m 644 %{SOURCE12} %{buildroot}/home/httpd/favicon.ico

%{__install} -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/lighttpd
%{__install} -m 644 %{SOURCE6} %{buildroot}%{_sysconfdir}/lighttpd/lighttpd.conf
%{__install} -m 644 %{SOURCE7} %{buildroot}%{_sysconfdir}/lighttpd/mime.conf
%{__install} -m 644 %{SOURCE8} %{buildroot}%{_sysconfdir}/lighttpd/conf.d/Default.conf
%{__install} -m 644 %{SOURCE9} %{buildroot}%{_sysconfdir}/lighttpd/conf.d/vhost.conf
%{__install} -m 644 %{SOURCE10} %{buildroot}%{_sysconfdir}/lighttpd/conf.d/README
%{__install} -m 644 %{SOURCE2} %{buildroot}/home/httpd/index.html

%{__install} -m 755 %{SOURCE4} %{buildroot}%{_sbindir}/lighttpd-monitor
%{__install} -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/sysconfig/lighttpd-monitor

%{__install} -m 755 %{SOURCE11} %{buildroot}%{_bindir}/lightdigest

%{__mkdir_p} %{buildroot}%{_datadir}/vim/vimfiles/{ftdetect,syntax}
%{__install} -m 644 %{SOURCE13} %{buildroot}%{_datadir}/vim/vimfiles/ftdetect/lighttpd.vim
%{__install} -m 644 %{SOURCE14} %{buildroot}%{_datadir}/vim/vimfiles/syntax/lighttpd.vim

#pushd %{buildroot}
#	find . -name "i386-annyung-linux-*" \
#			-exec rename "i386-annyung-linux-" "" {} \;
#	find . -name "i686-annyung-linux-*" \
#			-exec rename "i686-annyung-linux-" "" {} \;
#popd

#rm -rf %{buildroot}%{_libdir}/debug/

%clean
rm -rf %{buildroot}

%post
## read http://www.fedora.us/docs/spec.html next time :)
if test "$1" = "1"; then
  # real install, not upgrade
  /sbin/chkconfig --add lighttpd
  /sbin/chkconfig --level 35 lighttpd on
fi

%preun
if test "$1" = "0"; then
  # real uninstall, not upgrade
  %{_sysconfdir}/init.d/lighttpd stop &> /dev/null
  /sbin/chkconfig --del lighttpd
fi

%files
%defattr(-,root,root)
#doc doc/lighttpd.conf doc/lighttpd.user README
#doc doc/*.txt
%attr(0755,root,root) %{_sysconfdir}/init.d/lighttpd
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/sysconfig/lighttpd
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/sysconfig/lighttpd-monitor
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/lighttpd/lighttpd.conf
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/lighttpd/mime.conf
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/lighttpd/conf.d/Default.conf
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/lighttpd/conf.d/vhost.conf
%attr(0644,root,root) %{_sysconfdir}/lighttpd/conf.d/README
%attr(0644,root,root) %{_sysconfdir}/logrotate.d/lighttpd
%{_mandir}/*
%{_libdir}/lighttpd/*
%{_sbindir}/*
%{_bindir}/*
%dir /home/httpd
%attr(0775,root,nobody) %dir /var/log/lighttpd
%dir %{_sysconfdir}/lighttpd/
%dir %{_sysconfdir}/lighttpd/conf.d
/home/httpd/index.html
/home/httpd/favicon.ico

%dir %{_datadir}/lighttpd
%dir %{_datadir}/lighttpd/flags
%{_datadir}/lighttpd/*
%{_datadir}/vim/vimfiles/ftdetect/lighttpd.vim
%{_datadir}/vim/vimfiles/syntax/lighttpd.vim

%exclude %{_libdir}/lighttpd/*.la

%changelog
* Mon Feb  4 2013 JoungKyun.Kim <http://oops.org> 1:1.4.32-1
- fixed CVE-2012-533
- fixed typo dir-listing.html-lang
- Bug #2465: "ERROR: docroot is required for authorizer mode" although docroot is specified

* Sat Jan 28 2012 JoungKyun.Kim <http://oops.org> 1:1.4.30-1
- Bug #2376: Possible wrong info for Network-handler when you run "lighttpd -V"
- support answering Keep-Alive header with apache style
- support *(wild card character) within include directive
  http://redmine.lighttpd.net/issues/1221
- support local path on user define 404 page
- support tcp backlog on config file
- mod_dirlisting: add gallery function
- New config
  dir-listing.encoding
  dir-listing.html-lang
- New Modules
  mod_throttlestatus http://svn.oops.org/wsvn/Lighttpd.mod_throttlestatus/trunk/throttlestatus.ko.txt
  mod_url http://svn.oops.org/wsvn/Lighttpd.mod_url/trunk/README
  mod_net_access http://svn.oops.org/wsvn/Lighttpd.mod_net_access/trunk/README
  mod_auth_nis http://svn.oops.org/wsvn/Lighttpd.mod_auth_nis/trunk/README
  mod_krisp http://svn.oops.org/wsvn/Lighttpd.mod_krisp/trunk/README

* Tue Nov 30 2010 JoungKyun.Kim <http://oops.org> 15:1.4.28-1
- update 1.4.28
- fixed #2257 Silence annoying "connection closed: poll() -> ERR" error.log message
- fixed #2259 Fix mod_proxy waiting for response even if content-length is 0
- enables to set tcp backlog value with server.backlog directive
- changed krisp patch to krisp module
  remove server.krisp-used
- option changed
  server.meta-charset -> dir-listing.encoding
  server.html-lang    -> dir-listing.html-lang

* Sat Jun 20 2009 JoungKyun.Kim <http://oops.org> 14:1.4.22-1
- update 1.4.22
- fixed security
  CVE-2008-4359
- local user define 404 page is not redirect.

* Mon Oct 20 2008 JoungKyun.Kim <http://oops.org> 13:1.4.20-1
- 1.4.20 update
- Now really fix mod auth ldap (#1066)
- Fix base64 decoding in mod_auth (#1757, thx guido)
- Fix mod_cgi segfault when bound to unix domain socket (#653)
- Fix leaving zombie process with include_shell (#1777)
- Try to convert string options to shorts for numeric options in config file; allows to use env-vars for numeric options. (#1159, thx andrewb)
- Do not cache default vhost in mod_simple_vhost (#709)
- Fix fastcgi authorization in subdirectories with check-local=disabled; don't split pathinfo for authorizer. (#963)
- Fix duplicate connection keep-alive/transfer-encoding headers (#960)
- Fixed fix for round-robin in mod_proxy (forgot to increment the index) (#1715)
- Fixed fix for WebDAV MOVE doesn’t work when Destination contains login information (#1793)
- check return value of calloc in mod_simple_vhost.c (#1320)
- should match for complete mime-type and the part before ';' (#1552)
- mod_ssi PRINTENV does not print environment variables (#1713)
- add dir-listing.urlencode option. default value is enable.
- add mod_auth_nis module
- update mod_url revision 1.5

* Sun Jul  7 2008 JoungKyun.Kim <http://oops.org> 12:1.4.19-1
- update 1.4.19
- add official bug fix

* Fri Jul  4 2008 JoungKyun.Kim <oops@neowiz.com> 9:1.4.18-7
- suppoort http nis authenication

* Thu Mar  6 2008 JoungKyun.Kim <oops@neowiz.com> 8:1.4.18-6
- fixed 1.4.18-CVE-2008-1111
- remove broken workaround for buggy Opera version with ssl/chunked encoding (#285)
- prevent crash in certain php-fcgi configurations (#841)
- remove compress cache file if compression or write failed (#1150)
- generate etag/last-modified header for on-the-fly-compressed files (#1171)
- req-method OPTIONS: do not insert default response if request was denied, do not deny OPTIONS by default (#1324)
- fixed initgroups() called after chroot (#1384)
- do not suppress content on "307 Temporary Redirect" (#1412)
- fixed Content-Length header if response body gets removed in connections.c (#1412, part 2)
- execute fcgi app without /bin/sh if used as argument to spawn-fcgi (#1428) 
- reset conditional cache (#1164)
- do not add Accept-Ranges header if range-request is disabled (#1449)
- fixed case-sensitive check for Auth-Method (#1456)
- fixed a bug that made /-prefixed extensions being handled also when
  matching the end of the uri in fcgi,scgi and proxy modules (#1489) 
- log the ip of failed auth tries in error.log (enhancement #1544)
- fixed out of range access in fd array (#1562, #372)
- check for symlinks after successful pathinfo matching (#1574)
- spawn-fcgi: only try to connect to unix socket (not tcp) before spawning (#1575)
- fix min-procs handling in mod_scgi.c, just set to max-procs (patch from #623)

* Thu Oct 18 2007 JoungKyun.Kim <http://oops.org> 7:1.4.18-5
- add new mod_url module

* Fri Oct 12 2007 JoungKyun.Kim <http://oops.org> 6:1.4.18-4
- print user agent on server-status
- add lightdigest script

* Tue Oct  2 2007 JoungKyun.Kim <http://oops.org> 5:1.4.18-3
- fixed throttle-status ugly session counter

* Fri Sep 28 2007 JoungKyun.Kim <http://oops.org> 4:1.4.18-2
- add directory indexing forbidden patch on mod_indexfile
  index-file.forbid = "enable"

* Thu Sep 27 2007 JoungKyun.Kim <http://oops.org> 3:1.4.18-1
- update 1.4.18
- fixed 302 redirect handle return code bug on 1.4.16
- fixed hanging redirects with keep-alive due to missing "Content-Length: 0" headers on 1.4.17

* Thu Aug  8 2007 JoungKyun.Kim <http://oops.org> 2:1.4.16-1
- update 1.4.16
- add keepalive patch
- fixed sever-status html parsing error
- fixed throttle-status segfulat problem

* Thu Jun 14 2007 JoungKyun.Kim <http://oops.org> 1:1.4.15-1
- first packaged
- fixed official patch (#1226, #1230)
- patched #978
- patched #1220
- patched #1221
- patched krisp link
  use server.krisp-used = 1
- patched charset
  use server.meta-lang = "ko"
      server.html-charset = "euc-kr"
- patched rh9 anaconda support
  use server.rh9support = 1
